nose = {};
nose.quequeList = {};
nose.lastID = 1;
nose.minID = 1;
nose.isPlayingSound = false;
--RED
nose.quequeListRED = {};
nose.lastIDRED = 1;
nose.minIDRED = 1;
nose.isPlayingSoundRED = false;
--BLUE
nose.quequeListBLUE = {};
nose.lastIDBLUE = 1;
nose.minIDBLUE = 1;
nose.isPlayingSoundBLUE = false;
--NEUTRAL
nose.quequeListNEUTRAL = {};
nose.lastIDNEUTRAL = 1;
nose.minIDNEUTRAL = 1;
nose.isPlayingSoundNEUTRAL = false;


--publicfunctions-----------------------------------------------
function nose.QuequeSound(soundFile, soundDuration, text, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeList[nose.lastID] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = text,
							["textMatrix"] = nil,							
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelay(nose.lastID)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeList[nose.lastID]["soundFile"] .. ", id = " .. nose.lastID .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSound, nose.lastID, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSound, nose.lastID, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastID = nose.lastID + 1
end


function nose.DelayedQuequeSound(psoundFile, psoundDuration, ptext, ptextDuration, pclearText, pdelay, psoundPath)	
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeSound, {soundFile = psoundFile, soundDuration = psoundDuration, text = ptext, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end



function nose.QuequeSoundMultipleText(soundFile, soundDuration, textMatrix, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeList[nose.lastID] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = nil,																				
							["textMatrix"] = textMatrix,
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelay(nose.lastID)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeList[nose.lastID]["soundFile"] .. ", id = " .. nose.lastID .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSound, nose.lastID, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSound, nose.lastID, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastID = nose.lastID + 1
end



function nose.DelayedQuequeMultipleText(psoundFile, psoundDuration, ptextMatrix, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeMultipleText, {soundFile = psoundFile, soundDuration = psoundDuration, textMatrix = ptextMatrix, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end


function nose.ReserveLapse(LapseDuration)
	--trigger.action.outText("ReserveQueque", 3) 
	
	nose.quequeList[nose.lastID] = {
							["soundFile"] = "reserva",
							["soundDuration"] = LapseDuration,
                            ["text"] = nil,														
							["textDuration"] = 0,
							["clearText"] = false,
							["startTime"] = nil,
							["soundPath"] = nil,
							}
	
	local totalDelay = nose.CalcDelay(nose.lastID)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeList[nose.lastID]["soundFile"] .. ", id = " .. nose.lastID .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.playReserveLapse, nose.lastID, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSound, nose.lastID, timer.getTime() + totalDelay + LapseDuration)			
	
	nose.lastID = nose.lastID + 1
end


function nose.DelayedReserveLapse(pLapseDuration, pdelay)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.ReserveLapse, pLapseDuration, timer.getTime() + pdelay)
end


--End publicfunctions-----------------------------------------------



function nose.CalcDelay(currentID)	
	local totalTime = 1
	for id = nose.minID, nose.lastID do
		if id ~= currentID and nose.quequeList[id] ~= nil then
			if id == nose.minID and nose.quequeList[id]["startTime"] ~= nil then				
				--trigger.action.outText("Aun está sonando id:" .. id .. " y le quedan " .. nose.quequeList[id]["soundDuration"] -  (timer.getTime() - nose.quequeList[id]["startTime"]) .. " segundos", 3)
				totalTime = totalTime + nose.quequeList[id]["soundDuration"] -  (timer.getTime() - nose.quequeList[id]["startTime"])				
			else
				totalTime = totalTime + nose.quequeList[id]["soundDuration"]
			end			
		end	
	end		 
	--trigger.action.outText("CalcDelay from id =" .. nose.minID .. " to id = " .. nose.lastID.. ", totalDelay: ".. totalTime, 3)
	
	return totalTime
end


function nose.PlayQuequeSound(id)
	nose.quequeList[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Empieza a sonar [id= " ..id .."]: " .. nose.quequeList[id]["soundFile"].. ". Current Time = " .. timer.getTime(), 5) 
	
	local path = ""
	if nose.quequeList[id]["soundPath"] ~= nil then 
		path = nose.quequeList[id]["soundPath"] .. "/"	
	else
		path = "l10n/DEFAULT/"
	end	
	
	if nose.quequeList[id]["soundFile"] ~= nil and nose.quequeList[id]["soundFile"] ~= "" then trigger.action.outSound(path .. nose.quequeList[id]["soundFile"]) end
		
	if nose.quequeList[id]["text"] ~= nil and nose.quequeList[id]["text"] ~= "" then 
		trigger.action.outText(nose.quequeList[id]["text"], nose.quequeList[id]["textDuration"], nose.quequeList[id]["clearText"])
	elseif nose.quequeList[id]["textMatrix"] ~= nil	then
		if nose.quequeList[id]["clearText"] == true then trigger.action.outText("", 1, true) end
		for index = 1, #nose.quequeList[id]["textMatrix"] do 
			trigger.action.outText(nose.quequeList[id]["textMatrix"][index], nose.quequeList[id]["textDuration"], false)
		end
	end	
	
	nose.isPlayingSound = true	
end


function nose.EndQuequeSound(id)
	--trigger.action.outText("      Termina de sonar [id= " ..id .."]: " .. nose.quequeList[id]["soundFile"], 5) 
	--trigger.action.outText("      Nueva minID" .. nose.minID, 5)
	nose.minID = id + 1
	nose.isPlayingSound = false
end


function nose.playReserveLapse(id)
	nose.quequeList[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Reserva tiempo [id= " ..id .."]: " .. "Current Time = " .. timer.getTime(), 5) 
	
	nose.isPlayingSound = true	
end



function nose.doDelayedQuequeSound(parameters)
	nose.QuequeSound(parameters.soundFile, parameters.soundDuration, parameters.text, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


function nose.doDelayedQuequeMultipleText(parameters)
	nose.QuequeSoundMultipleText(parameters.soundFile, parameters.soundDuration, parameters.textMatrix, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


--RED------------------------------------------------------------------
--publicfunctions-----------------------------------------------
function nose.QuequeSoundRED(soundFile, soundDuration, text, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeListRED[nose.lastIDRED] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = text,
							["textMatrix"] = nil,							
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelayRED(nose.lastIDRED)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListRED[nose.lastIDRED]["soundFile"] .. ", id = " .. nose.lastIDRED .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSoundRED, nose.lastIDRED, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundRED, nose.lastIDRED, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastIDRED = nose.lastIDRED + 1
end


function nose.DelayedQuequeSoundRED(psoundFile, psoundDuration, ptext, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeSoundRED, {soundFile = psoundFile, soundDuration = psoundDuration, text = ptext, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end



function nose.QuequeSoundMultipleTextRED(soundFile, soundDuration, textMatrix, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeListRED[nose.lastIDRED] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = nil,																				
							["textMatrix"] = textMatrix,
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelayRED(nose.lastIDRED)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListRED[nose.lastIDRED]["soundFile"] .. ", id = " .. nose.lastIDRED .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSoundRED, nose.lastIDRED, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundRED, nose.lastIDRED, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastIDRED = nose.lastIDRED + 1
end



function nose.DelayedQuequeMultipleTextRED(psoundFile, psoundDuration, ptextMatrix, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeMultipleTextRED, {soundFile = psoundFile, soundDuration = psoundDuration, textMatrix = ptextMatrix, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end


function nose.ReserveLapseRED(LapseDuration)
	--trigger.action.outText("ReserveQueque", 3) 
	
	nose.quequeListRED[nose.lastIDRED] = {
							["soundFile"] = "reserva",
							["soundDuration"] = LapseDuration,
                            ["text"] = nil,														
							["textDuration"] = 0,
							["clearText"] = false,
							["startTime"] = nil,
							["soundPath"] = nil,
							}
	
	local totalDelay = nose.CalcDelayRED(nose.lastIDRED)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListRED[nose.lastIDRED]["soundFile"] .. ", id = " .. nose.lastIDRED .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.playReserveLapseRED, nose.lastIDRED, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundRED, nose.lastIDRED, timer.getTime() + totalDelay + LapseDuration)			
	
	nose.lastIDRED = nose.lastIDRED + 1
end


function nose.DelayedReserveLapseRED(LapseDuration, pdelay)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.ReserveLapseRED, LapseDuration, timer.getTime() + pdelay)
end


--End publicfunctions-----------------------------------------------

function nose.CalcDelayRED(currentID)	
	local totalTime = 1
	for id = nose.minIDRED, nose.lastIDRED do
		if id ~= currentID and nose.quequeListRED[id] ~= nil then
			if id == nose.minIDRED and nose.quequeListRED[id]["startTime"] ~= nil then				
				--trigger.action.outText("Aun está sonando id:" .. id .. " y le quedan " .. nose.quequeListRED[id]["soundDuration"] -  (timer.getTime() - nose.quequeListRED[id]["startTime"]) .. " segundos", 3)
				totalTime = totalTime + nose.quequeListRED[id]["soundDuration"] -  (timer.getTime() - nose.quequeListRED[id]["startTime"])				
			else
				totalTime = totalTime + nose.quequeListRED[id]["soundDuration"]
			end			
		end	
	end		 
	--trigger.action.outText("CalcDelay from id =" .. nose.minIDRED .. " to id = " .. nose.lastIDRED.. ", totalDelay: ".. totalTime, 3)
	
	return totalTime
end


function nose.PlayQuequeSoundRED(id)
	nose.quequeListRED[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Empieza a sonar [id= " ..id .."]: " .. nose.quequeListRED[id]["soundFile"].. ". Current Time = " .. timer.getTime(), 5) 
	
	local path = ""
	if nose.quequeListRED[id]["soundPath"] ~= nil then 
		 path = nose.quequeListRED[id]["soundPath"] .. "/"	
	else
		path = "l10n/DEFAULT/" 
	end	
	
	if nose.quequeListRED[id]["soundFile"] ~= nil and nose.quequeListRED[id]["soundFile"] ~= "" then trigger.action.outSoundForCoalition(coalition.side.RED, path .. nose.quequeListRED[id]["soundFile"]) end
		
	if nose.quequeListRED[id]["text"] ~= nil and nose.quequeListRED[id]["text"] ~= "" then 
		trigger.action.outTextForCoalition(coalition.side.RED, nose.quequeListRED[id]["text"], nose.quequeListRED[id]["textDuration"], nose.quequeListRED[id]["clearText"])
	elseif nose.quequeListRED[id]["textMatrix"] ~= nil	then
		if nose.quequeListRED[id]["clearText"] == true then trigger.action.outTextForCoalition(coalition.side.RED, "", 1, true) end
		for index = 1, #nose.quequeListRED[id]["textMatrix"] do 
			trigger.action.outTextForCoalition(coalition.side.RED, nose.quequeListRED[id]["textMatrix"][index], nose.quequeListRED[id]["textDuration"], false)
		end
	end	
	
	nose.isPlayingSoundRED = true	
end


function nose.EndQuequeSoundRED(id)
	--trigger.action.outText("      Termina de sonar [id= " ..id .."]: " .. nose.quequeListRED[id]["soundFile"], 5) 
	--trigger.action.outText("      Nueva minID" .. nose.minIDRED, 5)
	nose.minIDRED = id + 1
	nose.isPlayingSoundRED = false
end


function nose.playReserveLapseRED(id)
	nose.quequeListRED[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Reserva tiempo [id= " ..id .."]: " .. "Current Time = " .. timer.getTime(), 5) 
	
	nose.isPlayingSoundRED = true	
end



function nose.doDelayedQuequeSoundRED(parameters)
	nose.QuequeSoundRED(parameters.soundFile, parameters.soundDuration, parameters.text, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


function nose.doDelayedQuequeMultipleTextRED(parameters)
	nose.QuequeSoundMultipleTextRED(parameters.soundFile, parameters.soundDuration, parameters.textMatrix, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


--BLUE---------------------------------------------------------
--publicfunctions-----------------------------------------------
function nose.QuequeSoundBLUE(soundFile, soundDuration, text, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeListBLUE[nose.lastIDBLUE] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = text,
							["textMatrix"] = nil,							
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelayBLUE(nose.lastIDBLUE)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListBLUE[nose.lastIDBLUE]["soundFile"] .. ", id = " .. nose.lastIDBLUE .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSoundBLUE, nose.lastIDBLUE, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundBLUE, nose.lastIDBLUE, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastIDBLUE = nose.lastIDBLUE + 1
end


function nose.DelayedQuequeSoundBLUE(psoundFile, psoundDuration, ptext, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeSoundBLUE, {soundFile = psoundFile, soundDuration = psoundDuration, text = ptext, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end



function nose.QuequeSoundMultipleTextBLUE(soundFile, soundDuration, textMatrix, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeListBLUE[nose.lastIDBLUE] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = nil,																				
							["textMatrix"] = textMatrix,
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelayBLUE(nose.lastIDBLUE)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListBLUE[nose.lastIDBLUE]["soundFile"] .. ", id = " .. nose.lastIDBLUE .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSoundBLUE, nose.lastIDBLUE, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundBLUE, nose.lastIDBLUE, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastIDBLUE = nose.lastIDBLUE + 1
end



function nose.DelayedQuequeMultipleTextBLUE(psoundFile, psoundDuration, ptextMatrix, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeMultipleTextBLUE, {soundFile = psoundFile, soundDuration = psoundDuration, textMatrix = ptextMatrix, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end


function nose.ReserveLapseBLUE(LapseDuration)
	--trigger.action.outText("ReserveQueque", 3) 
	
	nose.quequeListBLUE[nose.lastIDBLUE] = {
							["soundFile"] = "reserva",
							["soundDuration"] = LapseDuration,
                            ["text"] = nil,														
							["textDuration"] = 0,
							["clearText"] = false,
							["startTime"] = nil,
							["soundPath"] = nil,
							}
	
	local totalDelay = nose.CalcDelayBLUE(nose.lastIDBLUE)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListBLUE[nose.lastIDBLUE]["soundFile"] .. ", id = " .. nose.lastIDBLUE .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.playReserveLapseBLUE, nose.lastIDBLUE, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundBLUE, nose.lastIDBLUE, timer.getTime() + totalDelay + LapseDuration)			
	
	nose.lastIDBLUE = nose.lastIDBLUE + 1
end


function nose.DelayedReserveLapseBLUE(LapseDuration, pdelay)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.ReserveLapseBLUE, LapseDuration, timer.getTime() + pdelay)
end

--End publicfunctions-----------------------------------------------


function nose.CalcDelayBLUE(currentID)	
	local totalTime = 1
	for id = nose.minIDBLUE, nose.lastIDBLUE do
		if id ~= currentID and nose.quequeListBLUE[id] ~= nil then
			if id == nose.minIDBLUE and nose.quequeListBLUE[id]["startTime"] ~= nil then				
				--trigger.action.outText("Aun está sonando id:" .. id .. " y le quedan " .. nose.quequeListBLUE[id]["soundDuration"] -  (timer.getTime() - nose.quequeListBLUE[id]["startTime"]) .. " segundos", 3)
				totalTime = totalTime + nose.quequeListBLUE[id]["soundDuration"] -  (timer.getTime() - nose.quequeListBLUE[id]["startTime"])				
			else
				totalTime = totalTime + nose.quequeListBLUE[id]["soundDuration"]
			end			
		end	
	end		 
	--trigger.action.outText("CalcDelay from id =" .. nose.minIDBLUE .. " to id = " .. nose.lastIDBLUE.. ", totalDelay: ".. totalTime, 3)
	
	return totalTime
end


function nose.PlayQuequeSoundBLUE(id)
	nose.quequeListBLUE[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Empieza a sonar [id= " ..id .."]: " .. nose.quequeListBLUE[id]["soundFile"].. ". Current Time = " .. timer.getTime(), 5) 
	
	local path = ""
	if nose.quequeListBLUE[id]["soundPath"] ~= nil then 
		path = nose.quequeListBLUE[id]["soundPath"] .. "/"	
	else
		path = "l10n/DEFAULT/"	
	end	
	
	if nose.quequeListBLUE[id]["soundFile"] ~= nil and nose.quequeListBLUE[id]["soundFile"] ~= "" then trigger.action.outSoundForCoalition(coalition.side.BLUE, path .. nose.quequeListBLUE[id]["soundFile"]) end
		
	if nose.quequeListBLUE[id]["text"] ~= nil and nose.quequeListBLUE[id]["text"] ~= "" then 
		trigger.action.outTextForCoalition(coalition.side.BLUE, nose.quequeListBLUE[id]["text"], nose.quequeListBLUE[id]["textDuration"], nose.quequeListBLUE[id]["clearText"])
	elseif nose.quequeListBLUE[id]["textMatrix"] ~= nil	then
		if nose.quequeListBLUE[id]["clearText"] == true then trigger.action.outTextForCoalition(coalition.side.BLUE, "", 1, true) end
		for index = 1, #nose.quequeListBLUE[id]["textMatrix"] do 
			trigger.action.outTextForCoalition(coalition.side.BLUE, nose.quequeListBLUE[id]["textMatrix"][index], nose.quequeListBLUE[id]["textDuration"], false)
		end
	end	
	
	nose.isPlayingSoundBLUE = true	
end


function nose.EndQuequeSoundBLUE(id)
	--trigger.action.outText("      Termina de sonar [id= " ..id .."]: " .. nose.quequeListBLUE[id]["soundFile"], 5) 
	--trigger.action.outText("      Nueva minID" .. nose.minIDBLUE, 5)
	nose.minIDBLUE = id + 1
	nose.isPlayingSoundBLUE = false
end


function nose.playReserveLapseBLUE(id)
	nose.quequeListBLUE[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Reserva tiempo [id= " ..id .."]: " .. "Current Time = " .. timer.getTime(), 5) 
	
	nose.isPlayingSoundBLUE = true	
end



function nose.doDelayedQuequeSoundBLUE(parameters)
	nose.QuequeSoundBLUE(parameters.soundFile, parameters.soundDuration, parameters.text, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


function nose.doDelayedQuequeMultipleTextBLUE(parameters)
	nose.QuequeSoundMultipleTextBLUE(parameters.soundFile, parameters.soundDuration, parameters.textMatrix, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end

--BLUE-----------------------------------------------------------
--publicfunctions-----------------------------------------------
function nose.QuequeSoundNEUTRAL(soundFile, soundDuration, text, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeListNEUTRAL[nose.lastIDNEUTRAL] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = text,
							["textMatrix"] = nil,							
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelayNEUTRAL(nose.lastIDNEUTRAL)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListNEUTRAL[nose.lastIDNEUTRAL]["soundFile"] .. ", id = " .. nose.lastIDNEUTRAL .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSoundNEUTRAL, nose.lastIDNEUTRAL, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundNEUTRAL, nose.lastIDNEUTRAL, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastIDNEUTRAL = nose.lastIDNEUTRAL + 1
end


function nose.DelayedQuequeSoundNEUTRAL(psoundFile, psoundDuration, ptext, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeSoundNEUTRAL, {soundFile = psoundFile, soundDuration = psoundDuration, text = ptext, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end



function nose.QuequeSoundMultipleTextNEUTRAL(soundFile, soundDuration, textMatrix, textDuration, clearText, soundPath)
	--trigger.action.outText("QuequeSound", 3) 
	
	nose.quequeListNEUTRAL[nose.lastIDNEUTRAL] = {
							["soundFile"] = soundFile,
							["soundDuration"] = soundDuration,
                            ["text"] = nil,																				
							["textMatrix"] = textMatrix,
							["textDuration"] = textDuration,
							["clearText"] = clearText,	
							["startTime"] = nil,
							["soundPath"] = soundPath,
							}
	
	local totalDelay = nose.CalcDelayNEUTRAL(nose.lastIDNEUTRAL)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListNEUTRAL[nose.lastIDNEUTRAL]["soundFile"] .. ", id = " .. nose.lastIDNEUTRAL .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.PlayQuequeSoundNEUTRAL, nose.lastIDNEUTRAL, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundNEUTRAL, nose.lastIDNEUTRAL, timer.getTime() + totalDelay + soundDuration)			
	
	nose.lastIDNEUTRAL = nose.lastIDNEUTRAL + 1
end



function nose.DelayedQuequeMultipleTextNEUTRAL(psoundFile, psoundDuration, ptextMatrix, ptextDuration, pclearText, pdelay, psoundPath)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.doDelayedQuequeMultipleTextNEUTRAL, {soundFile = psoundFile, soundDuration = psoundDuration, textMatrix = ptextMatrix, textDuration = ptextDuration, clearText = pclearText, soundPath = psoundPath}, timer.getTime() + pdelay)
end


function nose.ReserveLapseNEUTRAL(LapseDuration)
	--trigger.action.outText("ReserveQueque", 3) 
	
	nose.quequeListNEUTRAL[nose.lastIDNEUTRAL] = {
							["soundFile"] = "reserva",
							["soundDuration"] = LapseDuration,
                            ["text"] = nil,														
							["textDuration"] = 0,
							["clearText"] = false,
							["startTime"] = nil,
							["soundPath"] = nil,
							}
	
	local totalDelay = nose.CalcDelayNEUTRAL(nose.lastIDNEUTRAL)
	--trigger.action.outText("totalDelay = " .. totalDelay, 3)
	
	--trigger.action.outText("encolando sonido:" .. nose.quequeListNEUTRAL[nose.lastIDNEUTRAL]["soundFile"] .. ", id = " .. nose.lastIDNEUTRAL .. ", soundDuration = " .. soundDuration ..  ", delay: " .. totalDelay , 3) 
	timer.scheduleFunction(nose.playReserveLapseNEUTRAL, nose.lastIDNEUTRAL, timer.getTime() + totalDelay)			
	timer.scheduleFunction(nose.EndQuequeSoundNEUTRAL, nose.lastIDNEUTRAL, timer.getTime() + totalDelay + LapseDuration)			
	
	nose.lastIDNEUTRAL = nose.lastIDNEUTRAL + 1
end


function nose.DelayedReserveLapseNEUTRAL(LapseDuration, pdelay)
	if pdelay == 0 then pdelay = 1 end
	timer.scheduleFunction(nose.ReserveLapseNEUTRAL, LapseDuration, timer.getTime() + pdelay)
end


--End publicfunctions-----------------------------------------------



function nose.CalcDelayNEUTRAL(currentID)	
	local totalTime = 1
	for id = nose.minIDNEUTRAL, nose.lastIDNEUTRAL do
		if id ~= currentID and nose.quequeListNEUTRAL[id] ~= nil then
			if id == nose.minIDNEUTRAL and nose.quequeListNEUTRAL[id]["startTime"] ~= nil then				
				--trigger.action.outText("Aun está sonando id:" .. id .. " y le quedan " .. nose.quequeListNEUTRAL[id]["soundDuration"] -  (timer.getTime() - nose.quequeListNEUTRAL[id]["startTime"]) .. " segundos", 3)
				totalTime = totalTime + nose.quequeListNEUTRAL[id]["soundDuration"] -  (timer.getTime() - nose.quequeListNEUTRAL[id]["startTime"])				
			else
				totalTime = totalTime + nose.quequeListNEUTRAL[id]["soundDuration"]
			end			
		end	
	end		 
	--trigger.action.outText("CalcDelay from id =" .. nose.minIDNEUTRAL .. " to id = " .. nose.lastIDNEUTRAL.. ", totalDelay: ".. totalTime, 3)
	
	return totalTime
end


function nose.PlayQuequeSoundNEUTRAL(id)
	nose.quequeListNEUTRAL[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Empieza a sonar [id= " ..id .."]: " .. nose.quequeListNEUTRAL[id]["soundFile"].. ". Current Time = " .. timer.getTime(), 5) 
	
	local path = ""
	if nose.quequeListNEUTRAL[id]["soundPath"] ~= nil then 
		path = nose.quequeListNEUTRAL[id]["soundPath"] .. "/"	
	else
		path = "l10n/DEFAULT/"	
	end	
	
	if nose.quequeListNEUTRAL[id]["soundFile"] ~= nil and nose.quequeListNEUTRAL[id]["soundFile"] ~= "" then trigger.action.outSoundForCoalition(coalition.side.NEUTRAL, path .. nose.quequeListNEUTRAL[id]["soundFile"]) end
		
	if nose.quequeListNEUTRAL[id]["text"] ~= nil and nose.quequeListNEUTRAL[id]["text"] ~= "" then 
		trigger.action.outTextForCoalition(coalition.side.NEUTRAL, nose.quequeListNEUTRAL[id]["text"], nose.quequeListNEUTRAL[id]["textDuration"], nose.quequeListNEUTRAL[id]["clearText"])
	elseif nose.quequeListNEUTRAL[id]["textMatrix"] ~= nil	then
		if nose.quequeListNEUTRAL[id]["clearText"] == true then trigger.action.outTextForCoalition(coalition.side.NEUTRAL, "", 1, true) end
		for index = 1, #nose.quequeListNEUTRAL[id]["textMatrix"] do 
			trigger.action.outTextForCoalition(coalition.side.NEUTRAL, nose.quequeListNEUTRAL[id]["textMatrix"][index], nose.quequeListNEUTRAL[id]["textDuration"], false)
		end
	end	
	
	nose.isPlayingSoundNEUTRAL = true	
end


function nose.EndQuequeSoundNEUTRAL(id)
	--trigger.action.outText("      Termina de sonar [id= " ..id .."]: " .. nose.quequeListNEUTRAL[id]["soundFile"], 5) 
	--trigger.action.outText("      Nueva minID" .. nose.minIDNEUTRAL, 5)
	nose.minIDNEUTRAL = id + 1
	nose.isPlayingSoundNEUTRAL = false
end


function nose.playReserveLapseNEUTRAL(id)
	nose.quequeListNEUTRAL[id]["startTime"] = timer.getTime()
	--trigger.action.outText("      Reserva tiempo [id= " ..id .."]: " .. "Current Time = " .. timer.getTime(), 5) 
	
	nose.isPlayingSoundNEUTRAL = true	
end



function nose.doDelayedQuequeSoundNEUTRAL(parameters)
	nose.QuequeSoundNEUTRAL(parameters.soundFile, parameters.soundDuration, parameters.text, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


function nose.doDelayedQuequeMultipleTextNEUTRAL(parameters)
	nose.QuequeSoundMultipleTextNEUTRAL(parameters.soundFile, parameters.soundDuration, parameters.textMatrix, parameters.textDuration, parameters.clearText, parameters.soundPath)					
end


trigger.action.outText("N.O.S.E. v1.0", 5, false)
